{===================================================================================================

  Comming BASE

     . DBEdit, DBLookupCombo    .

====================================================================================================

  :

  01.09.2007 [*] .
  26.04.2004 [+]     (Lookup).
  20.04.2004 [*]  uses (Icarus).
  26.11.2002 [*]  ImageList.
  18.08.2002 [*]  TcoToolbarButton97  TcoButton.
  16.01.2002 [+] edFirld.
             [*]   TBASEDBLookupComboSF.
  12.12.2001 [+]  ReadOnly.
  06.12.2001 [+] Hint -.
             [+] Enabled:  .
  01.12.2001 [+]  .
  06.04.1999 [!]   BASE.

====================================================================================================
  Copyright 19992007 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: BASEsfDBEditLookupCombo.pas,v 1.4 2007/09/03 05:59:47 tsk Exp $
===================================================================================================}
unit BASEsfDBEditLookupCombo;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, Mask, DB,
      DBCtrls,
      // Comming:
      CommingLookupFlat, CommingFlat, CommingButton;

type
  TBASEDBEditLookupComboSF = class(TFrame)
    btLabel: TcoButton;
    cbField: TcoDBLookupCombo;
    edField: TcoDBEdit;
  private   { Private declarations }
    FEnabled:   Boolean;
    FReadOnly:  Boolean;
    procedure   SetEnabledX( const Value: Boolean );
    procedure   SetReadOnly(const Value: Boolean);
  public    { Public declarations }
    procedure   RequeryLookup( Lookup: TDataSource = nil );
    property    Enabled: Boolean read FEnabled write SetEnabledX;
    property    ReadOnly: Boolean read FReadOnly write SetReadOnly;
  end;

implementation

{$R *.dfm}
//==================================================================================================
{ TBASEDBEditLookupComboSF }
//==================================================================================================
procedure TBASEDBEditLookupComboSF.RequeryLookup(Lookup: TDataSource);
begin
  if cbField.LookupSource = nil then cbField.LookupSource := Lookup;
  if cbField.LookupSource <> nil then
    with cbField.LookupSource.DataSet do begin
      Close;
      Open;
    end;
end;
//==================================================================================================
procedure TBASEDBEditLookupComboSF.SetEnabledX( const Value: Boolean );
begin
  FEnabled := Value;
  btLabel.Enabled   := Value;
  edField.ReadOnly  := not Value;
  cbField.ReadOnly  := not Value;
end;
//==================================================================================================
procedure TBASEDBEditLookupComboSF.SetReadOnly( const Value: Boolean );
begin
  FReadOnly         := Value;
  edField.ReadOnly  := Value;
  cbField.ReadOnly  := Value;
  btLabel.NoClick   := Value
end;
//==================================================================================================
end.
