{=======================================================================================================================

  Comming BASE

       ( DBGrid).

========================================================================================================================

  :

  11.05.2013 [*] .
  24.07.2012 [*] .
  20.03.2011 [+]     .
  10.12.2003 [-]  uses (Icarus).
  05.08.2003 [+] TActionList    .
  01.08.2003 [+]   .
             [+]  "", "", "".
  20.12.2002 [+]  .
  06.04.1999 [!]   BASE.

========================================================================================================================
  Copyright 19992013 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: BASEfrChoiceGrid.pas,v 1.6 2013/08/14 05:51:45 tsk Exp $
=======================================================================================================================}
unit BASEfrChoiceGrid;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, ExtCtrls, DB, ADODB, Grids,
      ActnList, DBGridEh,
      // BASE:
      BASEfrRoot,
      // Comming:
      CommingButton, CommingDBGridEh;

type

  TChoice = procedure of object;
  TChoiceKey = procedure ( Key: Variant) of object;
  TCancel = procedure of object;

  TBASEChoiceDBGridFR = class( TBASERootFR )
    btAppend: TcoButton;
    btChoice: TcoButton;
    laTitle:  TStaticText;
    taChoice: TADODataSet;
    dsChoice: TDataSource;
    grChoice: TcoDBGridEh;
    btEdit: TcoButton;
    btDelete: TcoButton;
    alEdit: TActionList;
    acInsert: TAction;
    acEdit: TAction;
    acDelete: TAction;
    procedure btChoiceClick(Sender: TObject);
    procedure btCancelClick(Sender: TObject);
    procedure acInsertUpdate(Sender: TObject);
    procedure acEditUpdate(Sender: TObject);
  private   { Private declarations }
  public    { Public declarations }
    FieldKey: TField;
    OnChoice: TChoice;
    OnChoiceKey: TChoiceKey;
    OnCancel: TCancel;
    OnAfterChoice: TChoiceKey;
  end;

implementation

{$R *.DFM}
//======================================================================================================================
{ TBASEChoiceDBGridFR }
//======================================================================================================================
procedure TBASEChoiceDBGridFR.btChoiceClick( Sender: TObject );
begin
  if Assigned( OnChoice ) then OnChoice
    else if Assigned( OnChoiceKey ) then OnChoiceKey( FieldKey.Value );
  CloseModal;
  if Assigned( OnAfterChoice ) then OnAfterChoice( FieldKey.Value );
end;
//======================================================================================================================
procedure TBASEChoiceDBGridFR.btCancelClick(Sender: TObject);
begin
  if Assigned( OnCancel ) then OnCancel;
  inherited;
end;
//======================================================================================================================
{  }
//======================================================================================================================
procedure TBASEChoiceDBGridFR.acInsertUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := taChoice.Active;
end;
//======================================================================================================================
procedure TBASEChoiceDBGridFR.acEditUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := ( taChoice.Active ) and ( taChoice.RecordCount > 0 );
end;
//======================================================================================================================
end.
