{===================================================================================================

  Comming BASE

     .

====================================================================================================

  :

  31.10.2004 TSK  [+] DisplayWarning:  .
  28.10.2004 TSK  [+] DisplayMessage:  .
                  [+]  .
  06.04.1999 TSK  [!]   BASE.

====================================================================================================
  Copyright 19992004 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: BASEfrDisplay.pas,v 1.2 2004/11/23 07:27:30 tsk Exp $
===================================================================================================}
unit BASEfrDisplay;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, BASEfrRoot, CommingButton, ExtCtrls, StdCtrls;

type
  TBASEDisplayFR = class(TBASERootFR)
    imIcon: TImage;
    laText: TLabel;
    laTitle: TStaticText;
  private   { Private declarations }
  public    { Public declarations }
  end;

  procedure DisplayMessage( AOwner: TForm; Test: String );
  procedure DisplayWarning( AOwner: TForm; Test: String );

var BASEDisplayFR: TBASEDisplayFR;

implementation

{$R *.dfm}
//==================================================================================================
procedure DisplayMessage( AOwner: TForm; Test: String );
begin
  BASEDisplayFR := TBASEDisplayFR.Create( AOwner );
  BASEDisplayFR.imIcon.Picture.Icon.Handle  := LoadIcon(0, IDI_INFORMATION );
  BASEDisplayFR.laText.Caption := Test;
  BASEDisplayFR.ShowModal;
  Application.ProcessMessages;
end;
//==================================================================================================
procedure DisplayWarning(AOwner: TForm; Test: String);
begin
  BASEDisplayFR := TBASEDisplayFR.Create( AOwner );
  BASEDisplayFR.imIcon.Picture.Icon.Handle  := LoadIcon(0, IDI_WARNING );
  BASEDisplayFR.laText.Caption := Test;
  BASEDisplayFR.ShowModal;
  Application.ProcessMessages;
end;
//==================================================================================================
end.
