{=======================================================================================================================

  Comming BASE

    ,  .

========================================================================================================================

  :

  27.11.2004 [*] 
  20.10.2004 [+]  constructor.
  12.07.2003 [*]  Hint.
  14.05.2003 [+]  RadioButton.
  27.03.2003 [*]  TcoMemoryData  TcoPTable.
  27.08.2002 [*]  TcoToolbarButton97  TcoButton.
  08.02.2002 [-]  .
  30.01.2002 [*]     TcoMemoryData.
  01.11.2001 [*]       .
  26.10.2001 [*]     .
  13.08.2001 [+]  Query ().
  08.06.2001 [+]  .
  06.04.1999 [!]   BASE.

========================================================================================================================
  Copyright 19972004 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: BASEfrQuery.pas,v 1.7 2012/08/30 03:46:26 tsk Exp $
=======================================================================================================================}
unit BASEfrQuery;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ExtCtrls, DB,
      // BASE:
      BASEfrRoot,
      // Comming:
      CommingButton, CommingParameterTable, CommingRadioButton;

type

  TStayQuery = procedure of object;

  TBASEQueryFR = class( TBASERootFR )
    btGo: TcoButton;
    taQuery: TcoPTable;
    taQueryKind: TIntegerField;
    dsQuery: TDataSource;
    procedure btGoClick(Sender: TObject);
  private   { Private declarations }
    FOnStayQuery: TStayQuery;
    procedure   SetOnStayQuery( const Value: TStayQuery );
    procedure   SetRadioButton;
  public    { Public declarations }
    constructor Create( AOwner: TComponent ); override;
    constructor CreateComming( AOwner: TComponent; AProc: TStayQuery );
    procedure   GetRadioButton;
    // ,     "".
    property    OnStayQuery: TStayQuery read FOnStayQuery write SetOnStayQuery;
  end;

implementation

{$R *.DFM}
//======================================================================================================================
{ TBASEQueryFR }
//======================================================================================================================
constructor TBASEQueryFR.Create(AOwner: TComponent);
begin
  inherited Create( AOwner );
  taQuery.LoadRecordFromRegistry;
  SetRadioButton;
end;
//======================================================================================================================
constructor TBASEQueryFR.CreateComming( AOwner: TComponent; AProc: TStayQuery );
begin
  inherited Create( AOwner );
  OnStayQuery := AProc;
  taQuery.LoadRecordFromRegistry;
  SetRadioButton;
end;
//======================================================================================================================
procedure TBASEQueryFR.btGoClick( Sender: TObject );
begin
  if ( taQuery.State in [ dsInsert, dsEdit ] ) then taQuery.Post;
  taQuery.SaveRecordToRegistry;
  if Assigned( FOnStayQuery ) then FOnStayQuery;
  CloseModal;
end;
//======================================================================================================================
procedure TBASEQueryFR.SetOnStayQuery( const Value: TStayQuery );
begin
  FOnStayQuery := Value;
  btGo.Enabled := Assigned( FOnStayQuery );
end;
//======================================================================================================================
procedure TBASEQueryFR.GetRadioButton;
  var i: Integer;
begin
  if taQuery.State <> dsEdit then taQuery.Edit;
  taQueryKind.Value := 0;
  for i := 0 to ControlCount - 1 do
    if ( Controls[i] is TcoRadioButton ) and TcoRadioButton( Controls[i] ).Checked
      then taQueryKind.Value := Controls[i].Tag;
end;
//======================================================================================================================
procedure TBASEQueryFR.SetRadioButton;
  var i: Integer;
begin
  for i := 0 to ControlCount - 1 do
    if ( Controls[i] is TcoRadioButton ) and ( Controls[i].Tag = taQueryKind.Value )
      then TcoRadioButton( Controls[i] ).Checked := True;
end;
//======================================================================================================================
end.
