{===================================================================================================

  Comming BASE

     .   TEdit.

====================================================================================================

  :

  17.12.2006 [+]  .
  06.04.1999 [!]   BASE.

====================================================================================================
  Copyright 19992006 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: BASEsfButtonEdit.pas,v 1.2 2007/09/03 05:59:46 tsk Exp $
===================================================================================================}
unit BASEsfButtonEdit;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, Mask,
      DB, DBCtrls,
      // Comming:
      CommingFlat, CommingButton;

type
  TBASEButtonEditSF = class(TFrame)
    btLabel: TcoButton;
    edData: TcoEdit;
  private   { Private declarations }
    FEnabled:   Boolean;
    FReadOnly:  Boolean;
    procedure   _SetEnabled( const Value: Boolean );
    procedure   _SetReadOnly(const Value: Boolean);
  public    { Public declarations }
    property    Enabled: Boolean read FEnabled write _SetEnabled;
    property    ReadOnly: Boolean read FReadOnly write _SetReadOnly;
  end;

implementation

{$R *.dfm}
//==================================================================================================
{ TBASEButtonEditSF }
//==================================================================================================
procedure TBASEButtonEditSF._SetEnabled( const Value: Boolean );
begin
  FEnabled        := Value;
  btLabel.Enabled := Value;
  edData.ReadOnly := not Value;
end;
//==================================================================================================
procedure TBASEButtonEditSF._SetReadOnly( const Value: Boolean );
begin
  FReadOnly       := Value;
  edData.ReadOnly := Value;
  btLabel.NoClick := Value
end;
//==================================================================================================
end.
