{===================================================================================================

  Comming BASE

     .   (Edit),     (DBLookupCombo)
         .

====================================================================================================

  :

  20.04.2004 TSK  [*]  uses (Icarus).
  26.11.2002 TSK  [*]  ImageList.
  12.09.2002 TSK  [*]  TcoToolbarButton97  TcoButton.
                  [*]  ().
  16.01.2002 TSK  [+] edFirld.
                  [*]   TBASEDBLookupComboSF.
  12.12.2001 TSK  [+] ReadOnly.
  06.12.2001 TSK  [+] Hint -.
                  [+] Enabled:  .
  01.12.2001 TSK  [+]  .
  06.04.1999 TSK  [!]   BASE.

====================================================================================================
  Copyright 19992004 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: BASEsfEditLookupCombo.pas,v 1.4 2004/10/19 04:49:23 tsk Exp $
===================================================================================================}
unit BASEsfEditLookupCombo;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
      StdCtrls, Mask, DBCtrls,
      // Comming:
      CommingLookupFlat, CommingFlat, CommingButton;

type
  TBASEEditLookupComboSF = class(TFrame)
    btLable: TcoButton;
    cbField: TcoDBLookupCombo;
    edField: TcoEdit;
  private   { Private declarations }
    FEnabled:   Boolean;
    FReadOnly:  Boolean;
    procedure   SetEnabledX( const Value: Boolean );
    procedure   SetReadOnly( const Value: Boolean );
  public    { Public declarations }
    property    Enabled: Boolean read FEnabled write SetEnabledX;
    property    ReadOnly: Boolean read FReadOnly write SetReadOnly;
  end;

implementation

{$R *.dfm}
//==================================================================================================
{ TBASEEditLookupComboSF }
//==================================================================================================
procedure TBASEEditLookupComboSF.SetEnabledX( const Value: Boolean );
begin
  FEnabled := Value;
  btLable.Enabled   := Value;
  edField.ReadOnly  := not Value;
  cbField.ReadOnly  := not Value;
end;
//==================================================================================================
procedure TBASEEditLookupComboSF.SetReadOnly( const Value: Boolean );
begin
  FReadOnly         := Value;
  edField.ReadOnly  := Value;
  cbField.ReadOnly  := Value;
end;
//==================================================================================================
end.
