{===================================================================================================

  Comming BASE

        RichText  ADODataSet.

====================================================================================================

  :

  25.05.2004 TSK  [+] : Underline.
                  [+] : Italic.
                  [+] : Bold.
  24.05.2004 TSK  [+]  (Ctrl-V)
                  [+]  (Ctrl-C).
                  [+]  (Ctrl-X).
  20.05.2004 TSK  [*]   TBASEEditClientFR.
                  [+] ,   .
                  [+]   (ADO).
  09.05.2004 TSK  [+] edRichText:  .
                  [+] laName:  .
                  [+]  .
  06.04.1999 TSK  [!]   BASE.

====================================================================================================
  Copyright 19992004 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: BASEfrEditDBRTF.pas,v 1.6 2005/11/15 10:51:44 tsk Exp $
===================================================================================================}
unit BASEfrEditDBRTF;

interface

uses  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs, ActnList,
      TB2Item, TB2Dock, TB2Toolbar, ExtCtrls, StdCtrls, ComCtrls, DBCtrls, DB, ADODB, RichEdit,
      // BASE
      BASEfrRootClient, BASEfrEditClient,
      // Comming:
      CommingFlat, PropFilerEh, PropStorageEh;

type

  TAfterClose = procedure of object;

  TBASEDBRichEdit = class(TBASEEditClientFR)
    laName: TStaticText;
    edRichText: TcoDBRichEdit;
    acCut: TAction;
    TBItem1: TTBItem;
    acCopy: TAction;
    TBItem2: TTBItem;
    acPaste: TAction;
    TBItem3: TTBItem;
    TBSeparatorItem1: TTBSeparatorItem;
    acFont: TAction;
    dgFont: TFontDialog;
    TBItem4: TTBItem;
    TBSeparatorItem2: TTBSeparatorItem;
    imFontUnderline: TTBItem;
    imFontItalic: TTBItem;
    imFontBold: TTBItem;
    acFontBold: TAction;
    acFontItalic: TAction;
    acWordWarp: TAction;
    TBSeparatorItem5: TTBSeparatorItem;
    TBItem8: TTBItem;
    acFontUnderline: TAction;
    procedure acCutExecute(Sender: TObject);
    procedure acCopyExecute(Sender: TObject);
    procedure acPasteExecute(Sender: TObject);
    procedure acFontExecute(Sender: TObject);
    procedure acCutUpdate(Sender: TObject);
    procedure acPasteUpdate(Sender: TObject);
    procedure acFontBoldUpdate(Sender: TObject);
    procedure acFontBoldExecute(Sender: TObject);
    procedure acFontItalicUpdate(Sender: TObject);
    procedure acFontItalicExecute(Sender: TObject);
    procedure acWordWarpUpdate(Sender: TObject);
    procedure acWordWarpExecute(Sender: TObject);
    procedure acFontUnderlineUpdate(Sender: TObject);
    procedure acFontUnderlineExecute(Sender: TObject);
  private   { Private declarations }
    function    CurrText: TTextAttributes;
  public    { Public declarations }
  end;

implementation

{$R *.dfm}
//==================================================================================================
{ TBASEDBRichEdit }
//==================================================================================================
{procedure TBASEDBRichEdit.SelectionChange(Sender: TObject);
begin
  with edRichText.Paragraph do
    try
      FUpdating := True;
//      FirstInd.Left := Trunc(FirstIndent*RulerAdj)-4+GutterWid;
//      LeftInd.Left := Trunc((LeftIndent+FirstIndent)*RulerAdj)-4+GutterWid;
//      RightInd.Left := Ruler.ClientWidth-6-Trunc((RightIndent+GutterWid)*RulerAdj);
      imFontBold.Checked      := ( fsBold in edRichText.SelAttributes.Style );
      imFontItalic.Checked    := ( fsItalic in edRichText.SelAttributes.Style );
      imFontUnderline.Checked := ( fsUnderline in edRichText.SelAttributes.Style );
//      BulletsButton.Down := Boolean(Numbering);
//      FontSize.Text := IntToStr(Editor.SelAttributes.Size);
//      FontName.Text := Editor.SelAttributes.Name;
//      case Ord(Alignment) of
//        0: LeftAlign.Down := True;
//        1: RightAlign.Down := True;
//        2: CenterAlign.Down := True;
//      end;
//      UpdateCursorPos;
    finally
      FUpdating := False;
    end;
end; }
//==================================================================================================
function TBASEDBRichEdit.CurrText: TTextAttributes;
begin
  if edRichText.SelLength > 0
    then Result := edRichText.SelAttributes
    else Result := edRichText.DefAttributes;
end;
//==================================================================================================
{  }
//==================================================================================================
procedure TBASEDBRichEdit.acCutUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := ( edRichText.SelLength > 0 );
end;
//==================================================================================================
procedure TBASEDBRichEdit.acCutExecute(Sender: TObject);
begin
  edRichText.CutToClipboard;
end;
//==================================================================================================
procedure TBASEDBRichEdit.acCopyExecute(Sender: TObject);
begin
  edRichText.CopyToClipboard;
end;
//==================================================================================================
procedure TBASEDBRichEdit.acPasteUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := ( edRichText.HandleAllocated )
                             and ( edRichText.Perform(EM_CANPASTE, 0, 0) <> 0);
end;
//==================================================================================================
procedure TBASEDBRichEdit.acPasteExecute(Sender: TObject);
begin
  edRichText.PasteFromClipboard;
end;
//==================================================================================================
procedure TBASEDBRichEdit.acWordWarpUpdate(Sender: TObject);
begin
  TAction(Sender).Checked := ( edRichText.WordWrap );
end;
//==================================================================================================
procedure TBASEDBRichEdit.acWordWarpExecute(Sender: TObject);
begin
  edRichText.WordWrap := not ( TAction(Sender).Checked )
end;
//==================================================================================================
{  }
//==================================================================================================
procedure TBASEDBRichEdit.acFontExecute(Sender: TObject);
begin
  dgFont.Font.Assign(edRichText.SelAttributes);
  if dgFont.Execute then begin
    CurrText.Assign(dgFont.Font);
  end;
  edRichText.SetFocus;
end;
//==================================================================================================
procedure TBASEDBRichEdit.acFontBoldUpdate(Sender: TObject);
begin
  TAction(Sender).Checked := ( fsBold in edRichText.SelAttributes.Style )
end;
//==================================================================================================
procedure TBASEDBRichEdit.acFontBoldExecute(Sender: TObject);
begin
  if TAction(Sender).Checked
    then CurrText.Style := CurrText.Style - [fsBold]
    else CurrText.Style := CurrText.Style + [fsBold];
end;
//==================================================================================================
procedure TBASEDBRichEdit.acFontItalicUpdate(Sender: TObject);
begin
  TAction(Sender).Checked := ( fsItalic in edRichText.SelAttributes.Style )
end;
//==================================================================================================
procedure TBASEDBRichEdit.acFontItalicExecute(Sender: TObject);
begin
  if TAction(Sender).Checked
    then CurrText.Style := CurrText.Style - [fsItalic]
    else CurrText.Style := CurrText.Style + [fsItalic];
end;
//==================================================================================================
procedure TBASEDBRichEdit.acFontUnderlineUpdate(Sender: TObject);
begin
  TAction(Sender).Checked := ( fsUnderline in edRichText.SelAttributes.Style )
end;
//==================================================================================================
procedure TBASEDBRichEdit.acFontUnderlineExecute(Sender: TObject);
begin
  if TAction(Sender).Checked
    then CurrText.Style := CurrText.Style - [fsUnderline]
    else CurrText.Style := CurrText.Style + [fsUnderline];
end;
//==================================================================================================
end.
